#pragma once

// ClipboardFormatSnap.h: CClipboardFormatSnap NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

// [eBeB֐

/// tH[}bgԂ֐
LPCTSTR GetFormatName(int nFormat);

class CClipboardFormatSnap
{
	//
	// * Constructors
	//
public:
	CClipboardFormatSnap();
	CClipboardFormatSnap(const CClipboardFormatSnap& rhs);

	//
	// * Operators
	//
public:
	const CClipboardFormatSnap& operator = (const CClipboardFormatSnap& rhs);
	BOOL operator == (const CClipboardFormatSnap& rhs) const;
	BOOL operator != (const CClipboardFormatSnap& rhs) const;
	const CClipboardFormatSnap& operator + (const CClipboardFormatSnap& rhs);

	//
	// * Operations
	//
public:
	BOOL Capture( int nFormat );
	BOOL Restore();
	BOOL IsSameFormat( const CClipboardFormatSnap* const pFormatSnap );
	BOOL IsMergeableFormat();
	static BOOL IsMergeableFormat( const int nFormat );
	int FindReturn();
	void DeleteLastReturn();
	void Add( const char* const pAddedString, const BOOL bTop );
	BOOL IsEmpty();
///	const CClipboardFormatSnap& Merge( CClipboardFormatSnap& lhs, CClipboardFormatSnap& rhs );
protected:
	void DeleteLastReturn( const int nSizeOfNullTerminator );
	void Add( const char* const pAddedString, const BOOL bTop, const int nSizeOfNullTerminator );
	const int GetTextLength( const int nSizeOfNullTerminator );
	const int GetRTFBodyLength() const;
	const int GetRTFBodyHead() const;
	void MergeText( const CClipboardFormatSnap& rhs, const int nSizeOfNullTerminator );
	void MergeRTF( const CClipboardFormatSnap& rhs );

	//
	// * Attributes
	//
private:
	int m_nFormat;
#ifdef MFCDLL
	CArray<BYTE, BYTE> m_oData;
#else
	vector<BYTE> m_oData;
#endif
};
