/// @todo UNICODEΉ(Ǝv)

// ClipboardSnap.cpp: CClipboardSnap NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ClipboardSnap.h"
#include "Utils.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CClipboardSnap::CClipboardSnap(): m_pNext(NULL)
{
}

CClipboardSnap::~CClipboardSnap()
{
	ClearFormatSnaps();
}

//////////////////////////////////////////////////////////////////////
// Rs[
//////////////////////////////////////////////////////////////////////

/// Rs[RXgN^
CClipboardSnap::CClipboardSnap(const CClipboardSnap& rhs)
{
	// ClearFormatSnaps();							// ɒgȂ̂ŕsv
	// if (m_pNext) m_pNext->ClearFormatSnaps();	// ɒgȂ̂ŕsv

#ifdef MFCDLL
	INT_PTR n = rhs.m_oFormatSnaps.GetSize();
	m_oFormatSnaps.SetSize(n);
	int i;
#else
	size_t n = rhs.m_oFormatSnaps.size();
	m_oFormatSnaps.resize(n, NULL);
	size_t i;
#endif

	for (i = 0; i < n; i++) {
		try {
			m_oFormatSnaps[i] = new CClipboardFormatSnap;
//			if (m_oFormatSnaps[i])					// Oɗ邽ߕsv
				*m_oFormatSnaps[i] = *rhs.m_oFormatSnaps[i];
		}
#ifdef MFCDLL
		catch (CMemoryException* e) {
			e->Delete();
//			CUtils::Log("CClipboardSnap::CClipboardSnap: 'new' threw an exception");
		}
#else
		catch (bad_alloc) {
		}
#endif
	}

	m_pNext = rhs.m_pNext;
}

/// 
const CClipboardSnap& CClipboardSnap::operator = (const CClipboardSnap& rhs)
{
	ClearFormatSnaps();
	if (m_pNext) m_pNext->ClearFormatSnaps();

#ifdef MFCDLL
	INT_PTR n = rhs.m_oFormatSnaps.GetSize();
	m_oFormatSnaps.SetSize(n);
	int i;
#else
	size_t n = rhs.m_oFormatSnaps.size();
	m_oFormatSnaps.resize(n, NULL);
	size_t i;
#endif

	for (i = 0; i < n; i++) {
		try {
			m_oFormatSnaps[i] = new CClipboardFormatSnap;
//			if (m_oFormatSnaps[i])					// Oɗ邽ߕsv
				*m_oFormatSnaps[i] = *rhs.m_oFormatSnaps[i];
		}
#ifdef MFCDLL
		catch (CMemoryException* e) {
			e->Delete();
//			CUtils::Log("CClipboardSnap::operator=: 'new' threw an exception");
		}
#else
		catch (bad_alloc) {
		}
#endif
	}

	m_pNext = rhs.m_pNext;

	return *this;
}

/// v
BOOL CClipboardSnap::operator == (const CClipboardSnap& rhs) const
{
#ifdef MFCDLL
	INT_PTR n = m_oFormatSnaps.GetSize();
	INT_PTR nrhs = rhs.m_oFormatSnaps.GetSize();
	int i;
#else
	size_t n = m_oFormatSnaps.size();
	size_t nrhs = rhs.m_oFormatSnaps.size();
	size_t i;
#endif
	if (n != nrhs) return FALSE;

	for (i = 0; i < n; ++i)
		if (*m_oFormatSnaps[i] != *rhs.m_oFormatSnaps[i]) return FALSE;

	return TRUE;
}

/// sv
BOOL CClipboardSnap::operator != (const CClipboardSnap& rhs) const
{
	return !(*this == rhs);
}

/// ǉ
const CClipboardSnap& CClipboardSnap::operator += (const CClipboardSnap& rhs)
{
	const CClipboardSnap lhs = *this;

	// count the number of mergeable clipboard format
	int nMergeableClipboardFormatNumber = 0;
	struct MergeableClipboardFormatPosition
	{
		int m_nLHS;
		int m_nRHS;
	};

	const INT_PTR nMergeableClipboardFormatPosition = lhs.m_oFormatSnaps.GetSize() + rhs.m_oFormatSnaps.GetSize();
	try {
		MergeableClipboardFormatPosition *const pMergeableClipboardFormatPosition = new MergeableClipboardFormatPosition[ nMergeableClipboardFormatPosition ];
//		if( !pMergeableClipboardFormatPosition ) return *this;

		memset( pMergeableClipboardFormatPosition, -1, sizeof(MergeableClipboardFormatPosition) * nMergeableClipboardFormatPosition );

		for( int nLHS = 0; nLHS < lhs.m_oFormatSnaps.GetSize(); ++nLHS )	// LHS: Left Hand Side
		{
			if( lhs.m_oFormatSnaps[ nLHS ]->IsMergeableFormat() )
			{
				( pMergeableClipboardFormatPosition + nMergeableClipboardFormatNumber )->m_nLHS = nLHS;
				++nMergeableClipboardFormatNumber;
			}
		}
		for( int nRHS = 0; nRHS < rhs.m_oFormatSnaps.GetSize(); ++nRHS )	// RHS: Right Hand Side
		{
			if( rhs.m_oFormatSnaps[ nRHS ]->IsMergeableFormat() )
			{
				int i;
				for( i = 0; i < nMergeableClipboardFormatNumber; ++i )
				{
					if( ( pMergeableClipboardFormatPosition + i )->m_nLHS < 0 ) continue;
					if( rhs.m_oFormatSnaps[ nRHS ]->IsSameFormat( lhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nLHS ] ) ) break;
				}

				( pMergeableClipboardFormatPosition + i )->m_nRHS = nRHS;
				if( i ==  nMergeableClipboardFormatNumber )
				{
					++nMergeableClipboardFormatNumber;
				}
			}
		}

		// clear current data
#ifdef MFCDLL
		m_oFormatSnaps.RemoveAll();
		m_oFormatSnaps.SetSize(nMergeableClipboardFormatNumber);
#else
		m_oFormatSnaps.clear();
		m_oFormatSnaps.resize(nMergeableClipboardFormatNumber);
#endif

		// set data
		for( int i = 0; i < nMergeableClipboardFormatNumber; ++i )
		{
			CClipboardFormatSnap *pFormatSnap = new CClipboardFormatSnap;
//			if( pFormatSnap )
//			{
				m_oFormatSnaps[ i ] = pFormatSnap;
				if( ( ( pMergeableClipboardFormatPosition + i )->m_nLHS < 0 ) &&
					( ( pMergeableClipboardFormatPosition + i )->m_nRHS < 0 ) )
				{
					ASSERT( 0 );
				}
				else if( ( pMergeableClipboardFormatPosition + i )->m_nLHS < 0 )
				{
					*m_oFormatSnaps[ i ] = *rhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nRHS ];
				}
				else if( ( pMergeableClipboardFormatPosition + i )->m_nRHS < 0 )
				{
					*m_oFormatSnaps[ i ] = *lhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nLHS ];
				}
				else
				{
//					*lhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nLHS ] += *rhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nRHS ];
//					*m_oFormatSnaps[ i ] = *lhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nLHS ];
					*m_oFormatSnaps[ i ] = *lhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nLHS ] +
										   *rhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nRHS ];
//					m_oFormatSnaps[ i ]->Merge( *lhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nLHS ],
//												*rhs.m_oFormatSnaps[ ( pMergeableClipboardFormatPosition + i )->m_nRHS ] );
				}
//			}
		}
	}
#ifdef MFCDLL
	catch (CMemoryException* e) {
		e->Delete();
//		CUtils::Log("CClipboardSnap::operator+=: 'new' threw an exception");
	}
#else
	catch (bad_alloc) {
	}
#endif

	return *this;
}

//////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////

BOOL CClipboardSnap::Capture( const BOOL bTextOnly )
{
//	CUtils::Log( "CClipboardSnap::Capture(): start" );

	ClearFormatSnaps();
	if( !CUtils::OpenClipboard() ) return FALSE;

	int nFormat = 0;
	int nFormatCount = CountClipboardFormats();

	for( int i = 0; i < nFormatCount; i++ )
	{
		nFormat = EnumClipboardFormats( nFormat );
		if( nFormat == 0 ) break;
//		CUtils::Log("CClipboardSnap::Capture(): i = %d, nFormat = %d (%s)", i, nFormat, GetFormatName(nFormat));

		if( bTextOnly && !CClipboardFormatSnap::IsMergeableFormat( nFormat ) ) continue;

		// for Microsoft Word
		if( i && nFormat == 49163 ) continue;
		if( i && nFormat == 49156 ) continue;

		try {
			CClipboardFormatSnap *pFormatSnap = new CClipboardFormatSnap;

			if( /* pFormatSnap && */ !pFormatSnap->Capture( nFormat ) ) {
//				AfxMessageBox( _T("Capture Ignored or Failed:\n") + GetFormatName(nFormat) );
//				CUtils::Log( "CClipboardSnap::Capture(): Capture Ignored or Failed" );
			} else {
//				CUtils::Log( "CClipboardSnap::Capture(): add start" );
#ifdef MFCDLL
				m_oFormatSnaps.Add(pFormatSnap);
#else
				m_oFormatSnaps.push_back(pFormatSnap);
#endif
//				CUtils::Log( "CClipboardSnap::Capture(): add end" );
			}
		}
#ifdef MFCDLL
		catch (CMemoryException* e) {
			e->Delete();
//			CUtils::Log("CClipboardSnap::Capture: 'new' threw an exception");
		}
#else
		catch (bad_alloc) {
		}
#endif
	}

	CloseClipboard();
//	CUtils::Log( "CClipboardSnap::Capture(): end" );
	return TRUE;
}

BOOL CClipboardSnap::Restore()
{
	if( !CUtils::OpenClipboard() ) return FALSE;
	EmptyClipboard();

	for( int i = 0; i < m_oFormatSnaps.GetSize(); i++ )
	{
		m_oFormatSnaps[ i ]->Restore();
	}

	CloseClipboard();
	return TRUE;
}

void CClipboardSnap::ClearFormatSnaps()
{
	for( int i = 0; i < m_oFormatSnaps.GetSize(); i++ )
	{
		delete m_oFormatSnaps[ i ];
	}
#ifdef MFCDLL
	m_oFormatSnaps.RemoveAll();
#else
	m_oFormatSnaps.clear();
#endif

	if( m_pNext ) m_pNext->ClearFormatSnaps();
	m_pNext = NULL;
}

int CClipboardSnap::FindReturn()
{
	for( int i = 0; i < m_oFormatSnaps.GetSize(); ++i )
	{
		int rc = m_oFormatSnaps[ i ]->FindReturn();
		if( rc != -1 ) return rc;
	}
	return -1;
}

BOOL CClipboardSnap::IsEmpty()
{
	for( int i = 0; i < m_oFormatSnaps.GetSize(); ++i )
	{
		if( !m_oFormatSnaps[ i ]->IsEmpty() ) return FALSE;
	}
	return TRUE;
}

void CClipboardSnap::Add( const char *const pAddedString, const BOOL bTop )
{
	for( int i = 0; i < m_oFormatSnaps.GetSize(); ++i )
	{
		m_oFormatSnaps[ i ]->Add( pAddedString, bTop );
	}
}

void CClipboardSnap::DeleteLastReturn()
{
	for( int i = 0; i < m_oFormatSnaps.GetSize(); ++i )
	{
		m_oFormatSnaps[ i ]->DeleteLastReturn();
	}
}

void CClipboardSnap::SetNext( CClipboardSnap* pNext )
{
	if( m_pNext ) m_pNext->ClearFormatSnaps();
	m_pNext = pNext;
}

CClipboardSnap* CClipboardSnap::GetNext()
{
	return m_pNext;
}

BOOL CClipboardSnap::IsAllMergeableFormat()
{
	for( int i = 0; i < m_oFormatSnaps.GetSize(); ++i )
	{
		if( !m_oFormatSnaps[ i ]->IsMergeableFormat() ) return FALSE;
	}
	return TRUE;
}

int CClipboardSnap::GetCount()
{
	int nCount = 1;
	for( CClipboardSnap* pSnap = this; pSnap->GetNext(); pSnap = pSnap->GetNext() ) ++nCount;
	return ++nCount;
}
