#pragma once

// ClipboardSnap.h: CClipboardSnap NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#include "ClipboardFormatSnap.h"

class CClipboardSnap
{
	//
	// * Constructors
	//
public:
	CClipboardSnap();
	/* virtual */ ~CClipboardSnap();
	CClipboardSnap(const CClipboardSnap& rhs);

	//
	// * Operators
	//
public:
	const CClipboardSnap& operator = (const CClipboardSnap& rhs);
	BOOL operator == (const CClipboardSnap& rhs) const;
	BOOL operator != (const CClipboardSnap& rhs) const;
	const CClipboardSnap& operator += (const CClipboardSnap& rhs);

	//
	// * Operations
	//
public:
	BOOL Restore();
	BOOL Capture( const BOOL bTextOnly = FALSE );
	int FindReturn();
	void DeleteLastReturn();
	void Add( const char* const pAddedString, const BOOL bTop );
	BOOL IsEmpty();
	void SetNext( CClipboardSnap* pNext );
	CClipboardSnap* GetNext();
	BOOL IsAllMergeableFormat();
	int GetCount();
private:
	void ClearFormatSnaps();

	//
	// * Attributes
	//
private:
#ifdef MFCDLL
	CArray<CClipboardFormatSnap*, CClipboardFormatSnap*> m_oFormatSnaps;
#else
	vector<CClipboardFormatSnap*> m_oFormatSnaps;
#endif
	CClipboardSnap* m_pNext;
};
