// xkeymacsdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "Utils.h"
#include "Commands.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////

#ifdef MFCDLL
static AFX_EXTENSION_MODULE XkeymacsDLL;	// = { NULL, NULL };	///< MFC̉O
#endif

static HINSTANCE g_hInstance;		///< DLLA^b`vZX̃CX^Xnh

/// DLLJn
extern "C" int APIENTRY DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH) {
		g_hInstance = hInstance;
		CUtils::Attach();

#ifdef MFCDLL
//		TRACE0("xkeymacs.dll Initializing!\n");

		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(XkeymacsDLL, hInstance)) return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

/*
		try {
			new CDynLinkLibrary(XkeymacsDLL);
		}
		catch (CMemoryException* e) {
			e->Delete();
//			CUtils::Log("DllMain: 'new' threw an exception");
		}
*/
	} else if (dwReason == DLL_PROCESS_DETACH) {
//		TRACE0("xkeymacs.dll Terminating!\n");

		// Terminate the library before destructors are called
		AfxTermExtensionModule(XkeymacsDLL);
#endif
	}
	return 1;   // ok

	UNREFERENCED_PARAMETER(lpReserved);
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsDll Class
//////////////////////////////////////////////////////////////////////

#include "xkeymacsdll.h"

int CXkeymacsDll::ModifyShell_NotifyIcon(ICON_TYPE icon, BOOL bNewStatus, BOOL bForce)
{
	if (m_stNtfyIcon[icon].hIcon == (bNewStatus ? m_hIcon[icon][ON_ICON] : m_hIcon[icon][OFF_ICON])) {
		if (!bForce) {
			return TRUE;
		}
	} else {
		m_stNtfyIcon[icon].hIcon = (bNewStatus ? m_hIcon[icon][ON_ICON] : m_hIcon[icon][OFF_ICON]);
	}
	return DoShell_NotifyIcon(icon, NIM_MODIFY);
}

void CXkeymacsDll::SetNotifyIconData(ICON_TYPE icon, NOTIFYICONDATA stNtfyIcon, HICON hEnable, HICON hDisableTMP, HICON hDisableWOCQ, HICON hDisable, BOOL bEnable)
{
	m_hIcon[icon][STATUS_ENABLE] = hEnable;
	m_hIcon[icon][STATUS_DISABLE_TMP] = hDisableTMP;
	m_hIcon[icon][STATUS_DISABLE_WOCQ] = hDisableWOCQ;
	m_hIcon[icon][STATUS_DISABLE] = hDisable;
	m_bIcon[icon] = bEnable;
	m_stNtfyIcon[icon] = stNtfyIcon;
	AddShell_NotifyIcon(icon);
}

void CXkeymacsDll::SetNotifyIconData(ICON_TYPE icon, NOTIFYICONDATA stNtfyIcon, HICON hOn, HICON hOff, BOOL bEnable)
{
	m_hIcon[icon][ON_ICON] = hOn;
	m_hIcon[icon][OFF_ICON] = hOff;
	m_bIcon[icon] = bEnable;
	m_stNtfyIcon[icon] = stNtfyIcon;
	AddShell_NotifyIcon(icon);
}

void CXkeymacsDll::EnableShell_NotifyIcon(ICON_TYPE icon, BOOL bEnable)
{
	DeleteShell_NotifyIcon(icon);
	m_bIcon[icon] = bEnable;
	AddShell_NotifyIcon(icon);
}


BOOL CXkeymacsDll::DoShell_NotifyIcon(ICON_TYPE icon, DWORD dwMessage)
{
	if (m_bIcon[icon]
	 &&	(m_dwOldMessage[icon] != dwMessage
	  || memcmp(&m_stOldNtfyIcon[icon], &m_stNtfyIcon[icon], sizeof(m_stNtfyIcon[icon])))) {
		m_dwOldMessage[icon] = dwMessage;
		m_stOldNtfyIcon[icon] = m_stNtfyIcon[icon];

		// ʖڂȂƂ͉ĂʖڂȂŎԒZkB
		// 1b20  50ms3(100ms)ɕύXB
		// ^CAEgɂĂ2(50ms)̂ݗP\ƂB
		// {͏hɉeoȂ悤ÎŃG[GUIɔCƂB
		BOOL rc = FALSE;
		for (int retry_count = 0; retry_count < 3; ++retry_count) { // retry for timeout
			rc = Shell_NotifyIcon(dwMessage, &m_stNtfyIcon[icon]);
			if (dwMessage != NIM_ADD || rc || (GetLastError() != ERROR_TIMEOUT && 2 < retry_count)) {
				break;
			}
			dp("DoShell_NotifyIcon: Sleep\n");
			::Sleep(50);
			if ((rc = Shell_NotifyIcon(NIM_MODIFY, &m_stNtfyIcon[icon])) != FALSE) {
				break; // ERROR_TIMEOUT was returned but the icon was also added.
			}
		}
		return rc;
	} else {
		return TRUE;
	}
}

void CXkeymacsDll::AddShell_NotifyIcon(ICON_TYPE icon)
{
	DoShell_NotifyIcon(icon, NIM_ADD);
}

void CXkeymacsDll::DeleteShell_NotifyIcon(ICON_TYPE icon)
{
	DoShell_NotifyIcon(icon, NIM_DELETE);
}

/// tbNpe[u̎
const hooktable_t CXkeymacsDll::g_rHookTable[] = {
	{ WH_KEYBOARD,			ProcKeyboard },
	{ WH_CALLWNDPROC,		ProcCallWindow },
	{ WH_CALLWNDPROCRET,	ProcCallReturn },
	{ WH_GETMESSAGE,		ProcGetMessage },
	{ WH_SHELL,				ProcShell },
};

/// tbNpnhۑ̈
static HHOOK g_hHook[5];	// ASSERT(countof(g_rHookTable) <= 5)
#define g_hHookKeyboard g_hHook[0]
#define g_hHookCallWindow g_hHook[1]
#define g_hHookCallReturn g_hHook[2]
#define g_hHookGetMessage g_hHook[3]
#define g_hHookShell g_hHook[4]

/// O[otbNJn
HRESULT CXkeymacsDll::SetKeyboardHook()
{
	const hooktable_t* p = g_rHookTable;
	uint nMax = countof(g_rHookTable);
//	if (CUtils::IsV7orLater()) nMax--;
	for (uint i = 0; i < nMax; i++) {
		ASSERT(g_hHook[i] == NULL);
		g_hHook[i] = ::SetWindowsHookEx(p->id, p->func, g_hInstance, 0);
		if (g_hHook[i] == NULL) {
			ReleaseKeyboardHook();
			return E_FAIL;
		}
		p++;
	}

	FindAnotherWindow();
	if (s_hWndTarget) ::PostMessage(s_hWndTarget, WM_USER_FOUND, 0, 0);
	return S_OK;
}

/// O[otbN
HRESULT CXkeymacsDll::ReleaseKeyboardHook()
{
	HRESULT hResult = S_OK;
	for (uint i = 0; i < countof(g_rHookTable); i++) {
		if (g_hHook[i]) {
			if (::UnhookWindowsHookEx(g_hHook[i]) == FALSE) {
				hResult = E_FAIL;
			}
			g_hHook[i] = NULL;
		}
	}
	return hResult;
}

void CXkeymacsDll::SetKeyboardHookFlag()
{
	SetKeyboardHookFlag(m_bHook);
}

// ACRԂ̕ύX
void CXkeymacsDll::SetKeyboardHookFlag(BOOL bFlag)
{
	m_bHook = bFlag;

	if (m_bHook) {
		if (CCommands::IsTemporarilyDisableXKeymacs()) {
			m_stNtfyIcon[MAIN_ICON].hIcon = m_hIcon[MAIN_ICON][STATUS_DISABLE_TMP];
			m_hCurrentCursor = m_hCursor[STATUS_DISABLE_TMP];
		} else {
			m_stNtfyIcon[MAIN_ICON].hIcon = m_hIcon[MAIN_ICON][STATUS_ENABLE];
			m_hCurrentCursor = m_hCursor[STATUS_ENABLE];
		}
	} else {
		m_stNtfyIcon[MAIN_ICON].hIcon = m_hIcon[MAIN_ICON][STATUS_DISABLE_WOCQ];
		m_hCurrentCursor = m_hCursor[STATUS_DISABLE_WOCQ];
	}
	if (m_nSettingStyle[m_nApplicationID] == SETTING_DISABLE
		|| s_bEnable == FALSE
#ifdef XKEYMACS_DEFAULT_IGNORE
		|| m_nApplicationID == APPID_DEFAULT && CUtils::IsDefaultIgnoreApplication()
#endif
		) {
		m_stNtfyIcon[MAIN_ICON].hIcon = m_hIcon[MAIN_ICON][STATUS_DISABLE];
		m_hCurrentCursor = m_hCursor[STATUS_DISABLE];
	}
	DoShell_NotifyIcon(MAIN_ICON, NIM_MODIFY);
	DoSetCursor();
}

// if be keyboard hook, return TRUE
BOOL CXkeymacsDll::IsKeyboardHook()
{
	return m_bHook;
}

/*
void CXkeymacsDll::LogCallWndProcMessage(WPARAM wParam, LPARAM lParam)
{
	CWPSTRUCT &cwps = *(CWPSTRUCT*)lParam;

	switch (cwps.message) {
	case WM_PAINT:					// 0x000F
	case WM_MDIGETACTIVE:			// 0x0229
	case 0x0403:
	case 0x0407:
	case 0x0418:
	case 0x043F:
	case 0x0440:
		break;
	case WM_CREATE:					// 0x0001
		CUtils::Log(_T("CallWndProc: cwps.message = WM_CREATE"));
		break;
	case WM_DESTROY:				// 0x0002
		CUtils::Log(_T("CallWndProc: cwps.message = WM_DESTROY"));
		break;
	case WM_MOVE:					// 0x0003
		CUtils::Log(_T("CallWndProc: cwps.message = WM_MOVE"));
		break;
	case WM_SIZE:					// 0x0005
		CUtils::Log(_T("CallWndProc: cwps.message = WM_SIZE"));
		break;
	case WM_GETTEXT:				// 0x000D
		CUtils::Log(_T("CallWndProc: cwps.message = WM_GETTEXT"));
		break;
	case WM_ERASEBKGND:				// 0x0014
		CUtils::Log(_T("CallWndProc: cwps.message = WM_ERASEBKGND"));
		break;
	case WM_WINDOWPOSCHANGING:		// 0x0046
		CUtils::Log(_T("CallWndProc: cwps.message = WM_WINDOWPOSCHANGING"));
		break;
	case WM_WINDOWPOSCHANGED:		// 0x0047
		CUtils::Log(_T("CallWndProc: cwps.message = WM_WINDOWPOSCHANGED"));
		break;
	case WM_COPYDATA:				// 0x004A
		CUtils::Log(_T("CallWndProc: cwps.message = WM_COPYDATA"));
		break;
	case WM_NCCREATE:				// 0x0081
		CUtils::Log(_T("CallWndProc: cwps.message = WM_NCCREATE"));
		break;
	case WM_NCDESTROY:				// 0x0082
		CUtils::Log(_T("CallWndProc: cwps.message = WM_NCDESTROY"));
		break;
	case WM_NCCALCSIZE:				// 0x0083
		CUtils::Log(_T("CallWndProc: cwps.message = WM_NCCALCSIZE"));
		break;
	case WM_NCPAINT:				// 0x0085
		CUtils::Log(_T("CallWndProc: cwps.message = WM_NCPAINT"));
		break;
	case WM_IME_STARTCOMPOSITION:	// 0x010D
		CUtils::Log(_T("CallWndProc: cwps.message = WM_IME_STARTCOMPOSITION"));
		break;
	case WM_IME_ENDCOMPOSITION:		// 0x010E
		CUtils::Log(_T("CallWndProc: cwps.message = WM_IME_ENDCOMPOSITION"));
		break;
	case WM_IME_KEYLAST:			// 0x010F
		CUtils::Log(_T("CallWndProc: cwps.message = WM_IME_KEYLAST"));
		break;
	case WM_COMMAND:				// 0x0111
		CUtils::Log(_T("CallWndProc: cwps.message = WM_COMMAND"));
		break;
	case WM_CTLCOLOREDIT:			// 0x0133
		CUtils::Log(_T("CallWndProc: cwps.message = WM_CTLCOLOREDIT"));
		break;
	case WM_POWERBROADCAST:			// 0x0218
		CUtils::Log(_T("CallWndProc: cwps.message = WM_POWERBROADCAST"));
		switch (wParam) {
		case PBT_APMQUERYSUSPEND:		// 0x0000
			CUtils::Log(_T("PBT_APMQUERYSUSPEND"));
			break;
		case PBT_APMQUERYSTANDBY:		// 0x0001
			CUtils::Log(_T("PBT_APMQUERYSTANDBY"));
			break;
		case PBT_APMQUERYSUSPENDFAILED:	// 0x0002
			CUtils::Log(_T("PBT_APMQUERYSUSPENDFAILED"));
			break;
		case PBT_APMQUERYSTANDBYFAILED:	// 0x0003
			CUtils::Log(_T("PBT_APMQUERYSTANDBYFAILED"));
			break;
		case PBT_APMSUSPEND:			// 0x0004
			CUtils::Log(_T("PBT_APMSUSPEND"));
			break;
		case PBT_APMSTANDBY:			// 0x0005
			CUtils::Log(_T("PBT_APMSTANDBY"));
			break;
		case PBT_APMRESUMECRITICAL:		// 0x0006
			CUtils::Log(_T("PBT_APMRESUMECRITICAL"));
			break;
		case PBT_APMRESUMESUSPEND:		// 0x0007
			CUtils::Log(_T("PBT_APMRESUMESUSPEND"));
			break;
		case PBT_APMRESUMESTANDBY:		// 0x0008
			CUtils::Log(_T("PBT_APMRESUMESTANDBY"));
			break;
		case PBT_APMBATTERYLOW:			// 0x0009
			CUtils::Log(_T("PBT_APMBATTERYLOW"));
			break;
		case PBT_APMPOWERSTATUSCHANGE:	// 0x000A
			CUtils::Log(_T("PBT_APMPOWERSTATUSCHANGE"));
			break;
		case PBT_APMOEMEVENT:			// 0x000B
			CUtils::Log(_T("PBT_APMOEMEVENT"));
			break;
		case PBT_APMRESUMEAUTOMATIC:	// 0x0012
			CUtils::Log(_T("PBT_APMRESUMEAUTOMATIC"));
			break;
		default:
			CUtils::Log(_T("PBT_OTHERS: %d"), wParam);
			break;
		}
		break;
	case WM_IME_NOTIFY:				// 0x0282
		CUtils::Log(_T("CallWndProc: cwps.message = WM_IME_NOTIFY"));
		break;
	default:
		CUtils::Log(_T("CallWndProc: cwps.message = 0x%04X"), cwps.message);
		break;
	}
}
*/

LRESULT CALLBACK CXkeymacsDll::ProcCallWindow(int nCode, WPARAM wParam, LPARAM lParam)
{
//	LogCallWndProcMessage(wParam, lParam);

	if (0 <= nCode) {
		const CWPSTRUCT& cwps = *(CWPSTRUCT*)lParam;
		switch (cwps.message) {
/*
		case WM_IME_STARTCOMPOSITION:
			InitKeyboardProc(::GetFocus(), TRUE, 1);
			break;
		case WM_IME_ENDCOMPOSITION:
			InitKeyboardProc(::GetFocus(), FALSE, 2);
			break;
*/
		case WM_SETFOCUS:
			if (cwps.hwnd == ::GetForegroundWindow()) {
				if (InitKeyboardProc(cwps.hwnd, FALSE, 3))
					SetKeyboardHookFlag(m_bHook);
			}
			break;
		case WM_NCACTIVATE:
			if (cwps.wParam) {
				if (cwps.hwnd == ::GetForegroundWindow()) {
					if (InitKeyboardProc(cwps.hwnd, FALSE, 4))
						SetKeyboardHookFlag(m_bHook);
				}
			}
			break;
		case WM_POWERBROADCAST:
			switch (wParam) {
			case PBT_APMRESUMECRITICAL: // 0x0006
			case PBT_APMRESUMESUSPEND:  // 0x0007
			case PBT_APMRESUMESTANDBY:  // 0x0008
				ReleaseKeyboardHook();
				SetKeyboardHook();
				break;
			default:
				break;
			}
			break;
		}
	}
	return ::CallNextHookEx(g_hHookCallWindow, nCode, wParam, lParam);
}

/// EBhEύXƃJ[\ύX
LRESULT CALLBACK CXkeymacsDll::ProcCallReturn(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (0 <= nCode) {
		const CWPRETSTRUCT& cwprets = *(CWPRETSTRUCT*)lParam;
		switch (cwprets.message) {
		case WM_SETTEXT:
//			CUtils::RefreshApplicationName();
			if (cwprets.hwnd == ::GetForegroundWindow()) {	// ̍XV̂ł͕̔K{
				InitKeyboardProc(cwprets.hwnd, FALSE, 5);
			}
			break;
		case WM_SETCURSOR:
			DoSetCursor();
			break;
		}
	}
	return ::CallNextHookEx(g_hHookCallReturn, nCode, wParam, lParam);
}

/// łȂvZX̗: Firefox, Thunderbird
LRESULT CALLBACK CXkeymacsDll::ProcGetMessage(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (0 <= nCode) {
		const MSG& msg = *(MSG*)lParam;
		switch (msg.message) {
		case WM_IME_STARTCOMPOSITION:
			InitKeyboardProc(::GetForegroundWindow(), TRUE, 6);	// msg.hwnd IMEȂ̂Ŏgp֎~
			break;
		case WM_IME_ENDCOMPOSITION:
			InitKeyboardProc(::GetForegroundWindow(), FALSE, 7);
			break;
		}
	}
	return ::CallNextHookEx(g_hHookGetMessage, nCode, wParam, lParam);
}

// ӁĨCxg GetFocus gps
// łȂvZX̗: R}hvvg(Windows XP̂݁Axkeymacs.exẽvZXŌo)
LRESULT CALLBACK CXkeymacsDll::ProcShell(int nCode, WPARAM wParam, LPARAM lParam)
{
	ASSERT(HSHELL_WINDOWACTIVATED >= 0);
	if (nCode == HSHELL_WINDOWACTIVATED) {
		HWND hWnd = (HWND)wParam;
		TCHAR buf[32];	// = { 0 };	// ͕KI[邪s͉܂Ȃ
		buf[0] = _T('\0');			// SNA擪1̂݃NA
		::GetClassName(hWnd, buf, countof(buf));	// ܂ő啶̓obt@-1
		if (_tcsicmp(buf, _T("ConsoleWindowClass")) == 0) {
			if (InitKeyboardProc(hWnd, FALSE, 8))
				SetKeyboardHookFlag(m_bHook);
		}
	}
	return ::CallNextHookEx(g_hHookShell, nCode, wParam, lParam);
}

// return true if the key is down
BOOL CXkeymacsDll::IsDown(BYTE bVk, BOOL bPhysicalKey)
{
	if (bPhysicalKey) {
		return GetKeyState(bVk) < 0;
	} else {
		return GetAsyncKeyState(bVk) < 0;
	}
}

// Do keybd_event
void CXkeymacsDll::DoKeybd_event(BYTE bVk, DWORD dwFlags)
{
	// Set KEYEVENTF_EXTENDEDKEY if needed
	switch (bVk) {
	case VK_CONTROL:
		if (m_bRightControl) {		// Right Ctrl
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_MENU:
		if (m_bRightAlt) {			// Right Alt
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
//			CUtils::Log("Right Alt %d", dwFlags);
//		} else {
//			CUtils::Log("Left Alt %d", dwFlags);
		}
		break;

	case VK_SHIFT:
		if (m_bRightShift) {		// Right Shift
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_PAUSE:
		if (IsDown(VK_CONTROL)) {	// Break
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_NEXT:
	case VK_PRIOR:
	case VK_UP:
	case VK_DOWN:
	case VK_RIGHT:
	case VK_LEFT:
	case VK_NUMLOCK:
	case VK_PRINT:
		dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	default:
		break;
	}

//	CUtils::Log(_T("b: %x, %x, %x, %#x, %#x"), bVk, dwFlags, GetMessageExtraInfo(), GetKeyState(bVk), GetAsyncKeyState(bVk));
	keybd_event(bVk, 0, dwFlags, GetMessageExtraInfo());
//	CUtils::Log(_T("a: %x, %x, %x, %#x, %#x"), bVk, dwFlags, GetMessageExtraInfo(), GetKeyState(bVk), GetAsyncKeyState(bVk));
}

// the key is being depressed
void CXkeymacsDll::DepressKey(BYTE bVk, BOOL bOriginal)	// bVk is virtual-key code, MSDN said
{
	if (bOriginal) {
//		CUtils::Log(_T("i: %x, %d, %d, %d, %d, %d, %d, %d, %d"), bVk,
//			IsDown(VK_CONTROL), IsDown(VK_CONTROL, FALSE), IsDepressedModifier(CCommands::C_), IsDepressedModifier(CCommands::C_, FALSE),
//			IsDown(VK_MENU), IsDown(VK_MENU, FALSE), IsDepressedModifier(CCommands::MetaAlt), IsDepressedModifier(CCommands::MetaAlt, FALSE));

		int nCommandType = NONE;
		if (IsDown(VK_CONTROL, FALSE)) {
			nCommandType |= CONTROL;
		}
		if (IsDown(VK_MENU, FALSE)) {
			nCommandType |= META;
		}
		Original(nCommandType, bVk, 1);
	}

	DoKeybd_event(bVk, 0);
}

// the key is being released
void CXkeymacsDll::ReleaseKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, KEYEVENTF_KEYUP);
}

// bVk down, bVk up
void CXkeymacsDll::Kdu(BYTE bVk, DWORD n, BOOL bOriginal)
{
	while (n--) {
		DepressKey(bVk, bOriginal);
		ReleaseKey(bVk);
	}
}

/// ̃EBhET
void CXkeymacsDll::FindAnotherWindow()
{
#ifdef x64
	s_hWndTarget = ::FindWindow(_T("XKeymacs"), NULL);
#else
	s_hWndTarget = ::FindWindow(_T("XKeymacs64"), NULL);
#endif
	dp(ARCHNAME "bit FindWindow %X\n", s_hWndTarget);
}

/// L[𖳌
void CXkeymacsDll::SetKeyboardProc(BOOL bEnable)
{
	s_bEnable = bEnable;
	dp(s_bEnable ? ARCHNAME "bit enabled\n" : ARCHNAME "bit disabled\n");
}

/// oꂽCxgɑΏۂύX
BOOL CXkeymacsDll::InitKeyboardProc(HWND hWnd, BOOL bImeComposition, DWORD nDebugNumber)
{
	// vZX擾ƃA[LeN`Ԃł̓e̓(ʓIɂ̓tÔݓ)
	if (CUtils::UpdateApplicationName(hWnd, bImeComposition, nDebugNumber) == FALSE &&
		s_bEnable == TRUE) return FALSE;	// 菇dv
	SetKeyboardProc(TRUE);

	// GUIŃtB^ύXĂ̂Ŋ񐶂ĂvZX̌ႭĂʒm
	if (s_hWndTarget) ::PostMessage(s_hWndTarget, WM_USER_FOCUS, 0, 0);

#if 0
	/// @bug ̌_CAOɕ͂ăJ[\ʒu𖖔ȊOɈړԂœ{͂ƏɃJ[\Ɉړ̂͂̃R[ĥ
	if (CUtils::IsFindDialog()) {
		static BOOL bImeCompositionOld;	// = FALSE;
		if (!bImeComposition && bImeCompositionOld) {	// IMEtO̗o
			DepressKey(VK_END);
			ReleaseKey(VK_END);
		}
		bImeCompositionOld = bImeComposition;
	}
#endif

	// Avԍ擾
	/// @todo |C^ϒzev[g+nbV
	if (bImeComposition || !CUtils::IsDialog()) {
		// Avԍ m_nApplicationID ɑ
		// Ȃ m_nApplicationID = 0 (Default)
		m_nApplicationID = APPID_DEFAULT;
		for (uint i = APPID_USER; i < MAX_APP; i++) {
			if (_tcsicmp(m_szSpecialApp[i], CUtils::GetApplicationName()) == 0) {
				m_nApplicationID = i;
				break;
			}
		}
	} else {
		// _CAO
		m_nApplicationID = APPID_DIALOG;
	}
	dp(ARCHNAME ": Ime %d Dialog %d Application %d\n", bImeComposition, CUtils::IsDialog(), m_nApplicationID);

	ModifyShell_NotifyIcon(CX_ICON, FALSE);
	ModifyShell_NotifyIcon(MX_ICON, FALSE);
	ModifyShell_NotifyIcon(META_ICON, FALSE);
	CCommands::SetMark(FALSE);
	CCommands::SetTemporarilyDisableXKeymacs(FALSE);
	CCommands::Reset();
	return TRUE;
}

// emulate emacs	// cf virtual-key code
LRESULT CALLBACK CXkeymacsDll::ProcKeyboard(int nCode, WPARAM wParam, LPARAM lParam)
{
	ASSERT(0 <= wParam && wParam <= UCHAR_MAX);

	if (nCode < 0 || nCode == HC_NOREMOVE) {
		goto DO_NOTHING_QUIT;
	}

#ifdef XKEYMACS_STRICT_ARCHITECTURE
	// قȂA[LeN`ɑ΂Ĉ؏sȂȂ
	// 64rbgWindows̎dlɂA64rbg̃EBhEŔ
	// L[Cxg32rbg̃tbNɗꍞމ\
	// (Ƃꍞ܂ȂP[X܂ČłȂ)̂
	// ̑΍̂߂̎bŃeXgR[h
	// A[LeN`ԘAgɂsvƂȂPƎsɂ͌Ȕ肪KvɂȂ鎞邩Ȃ̂ŎcĂ
	dp(ARCHNAME "bit code:%X w:%X arch:%X\n", nCode, wParam, CUtils::IsDifferentArchitecture(::GetForegroundWindow()));
	if (CUtils::IsDifferentArchitecture(::GetForegroundWindow())) goto DO_NOTHING_QUIT;
#endif

	// ANeBûݏ
	dp(ARCHNAME "bit code:%X w:%X active:%X\n", nCode, wParam, s_bEnable);
	if (s_bEnable == FALSE) goto DO_NOTHING_QUIT;

	const BYTE RECURSIVE_KEY = 0x07;
	static BOOL bLocked;					// = FALSE;
	static int (*fCommand)();				// = NULL;
	static BYTE nOneShotModifier[MAX_KEY];	// = {'\0'};
	static BOOL bCherryOneShotModifier;		// = FALSE;
	static BOOL bShift;						// = FALSE;

	BYTE nKey = (BYTE)wParam;

//	CUtils::Log(_T("nCode = %#x, nKey = %#x, lParam = %#x"), nCode, nKey, lParam);

	if (nKey == RECURSIVE_KEY) {
		if (lParam & BEING_RELEASED) {
			goto HOOK_RECURSIVE_KEY;
		} else {
			goto RECURSIVE_COMMAND;
		}
	}

	if (IsDepressedShiftKeyOnly(nKey)) {
		if (lParam & BEING_RELEASED) {
			if (bShift) {
				CCommands::SetMark(FALSE);
			}
		} else {
			bShift = TRUE;
		}
	} else {
		bShift = FALSE;
	}

	if (CUtils::IsNT()) {
		switch (nKey) {
		case VK_CONTROL:
			if (lParam & EXTENDED_KEY) {
				nKey = VK_RCONTROL;
			} else {
				nKey = VK_LCONTROL;
			}
			break;
		case VK_MENU:
			if (lParam & EXTENDED_KEY) {
				nKey = VK_RMENU;
			} else {
				nKey = VK_LMENU;
			}
			break;
		case VK_SHIFT:
			if (lParam & EXTENDED_KEY) {
				nKey = VK_RSHIFT;
			} else {
				nKey = VK_LSHIFT;
			}
			break;
		default:
			break;
		}
	}

	if (lParam & BEING_RELEASED) {
		if (nKey == VK_MENU
		 || nKey == VK_LWIN
		 || nKey == VK_RWIN
		 || nKey == VK_APPS
		 || nKey == VK_LMENU
		 || nKey == VK_RMENU) {
			for (int i = 0; i < MAX_COMMAND_TYPE; ++i) {
				if (Commands[m_nCommandID[m_nApplicationID][i][nKey]].fCommand
				 && (Commands[m_nCommandID[m_nApplicationID][i][nKey]].fCommand != CCommands::MetaAlt
				  || nKey != VK_MENU && nKey != VK_LMENU && nKey != VK_RMENU)) {
					goto HOOK;
				}
			}
		}

		if (nOneShotModifier[nKey]) {
			ReleaseKey(nOneShotModifier[nKey]);
			nOneShotModifier[nKey] = 0;

			if (bCherryOneShotModifier) {
				bCherryOneShotModifier = FALSE;
				Kdu(nKey);
			}
		}

		goto DO_NOTHING;
	}

	if (m_nSettingStyle[m_nApplicationID] == SETTING_DISABLE) {
		goto DO_NOTHING;
	}

#ifdef XKEYMACS_DEFAULT_IGNORE
	// Do Nothing for Meadow, Mule for Win32, ... if those use default setting.
	if (m_nApplicationID == APPID_DEFAULT
	 && CUtils::IsDefaultIgnoreApplication()) {
		goto DO_NOTHING;
	}
#endif

	switch (IsPassThrough(nKey)) {
	case GOTO_DO_NOTHING:
		goto DO_NOTHING;
	case GOTO_HOOK:
		goto HOOK;
	case CONTINUE:
		break;
	default:
		ASSERT(0);
		break;
	}

	// set command type
	int nCommandType = NONE;
	if (IsDown(VK_SHIFT, FALSE)) {
		nCommandType |= SHIFT;
	}
	if (IsControl()) {
		nCommandType |= CONTROL;
	}
	if (IsMeta()) {
		nCommandType |= META;
	}
	if (CCommands::bC_x()) {
		nCommandType |= CONTROLX;
	}

	// Ignore undefined C-x ?
	if (nCommandType & CONTROLX) {
		if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == NULL
			&& m_nFunctionID[m_nApplicationID][nCommandType][nKey] < 0) {
			if (m_bIgnoreUndefinedC_x[m_nApplicationID]) {
				CCommands::Reset(GOTO_HOOK);
				goto HOOK;
			}
			nCommandType &= ~CONTROLX;
		}
	}

	// Ignore undefined Meta Ctrl+?
	if (CCommands::bM_() && (nCommandType & CONTROL)) {
		if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == NULL
			&& m_nFunctionID[m_nApplicationID][nCommandType][nKey] < 0) {
			if (m_bIgnoreUndefinedMetaCtrl[m_nApplicationID]) {
				if (Original(CONTROL, nKey)) {
					Original(CONTROL, nKey, -1);
					goto DO_NOTHING;
				}
				CCommands::Reset(GOTO_HOOK);
				goto HOOK;
			}
			nCommandType &= ~META;
		}
	}

	{
//		CUtils::Log(_T("o: %x, %d, %d, %d, %d, %d, %d, %d, %d"), (BYTE)wParam,
//			IsDown(VK_CONTROL), IsDown(VK_CONTROL, FALSE), IsDepressedModifier(CCommands::C_), IsDepressedModifier(CCommands::C_, FALSE),
//			IsDown(VK_MENU), IsDown(VK_MENU, FALSE), IsDepressedModifier(CCommands::MetaAlt), IsDepressedModifier(CCommands::MetaAlt, FALSE));

		BYTE nKey = (BYTE)wParam; // VK_CONTROL is needed instead of VK_RCONTROL and VK_LCONTROL in this block just for Original()
		int nVirtualCommandType = NONE;
		if (IsDown(VK_CONTROL) && nKey != VK_CONTROL) {
			nVirtualCommandType |= CONTROL;
		}
		if (IsDown(VK_MENU) && nKey != VK_MENU) {
			nVirtualCommandType |= META;
		}
		if (Original(nVirtualCommandType, nKey)) {
			Original(nVirtualCommandType, nKey, -1);
			goto DO_NOTHING;
		}
	}

	if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::EnableOrDisableXKeymacs) {
		SetKeyboardHookFlag(!m_bHook);
		goto HOOK;
	}
	if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::EnableXKeymacs) {
		if (!m_bHook) {
			SetKeyboardHookFlag(!m_bHook);
		}
		goto HOOK;
	}
	if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::DisableXKeymacs) {
		if (m_bHook) {
			SetKeyboardHookFlag(!m_bHook);
		}
		goto HOOK;
	}
	if (!m_bHook) {
		goto DO_NOTHING;
	}

	// M-x Cobt@̕ҏW
	if (CCommands::bM_x()) {
		static size_t index;	// = 0;
		static TCHAR szPath[MAX_PATH];	// = { 0 };	// kݏ蔲Ă邽߁Aindex = 0 ɂꍇ͓ szPath SNÃR[hKvɂȂĂ܂ĂB܂A̖ _tcslen ŖvẐ͌B܂A̎̕񏈗DLLɕKvȂ̂H M-x @\̎gĂ̂HȂǂ𖾊mɂsvł΍폜B	// @todo 1폜ɖƃNAĂ̂mF

		if (lParam & BEING_RELEASED) {
			// ignore
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::BackwardChar) {
			if (index) {
				--index;
			}
			goto HOOKX;
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::BeginningOfLine) {
			index = 0;
			goto HOOKX;
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::DeleteBackwardChar) {
			if (index) {
				--index;
				memmove(&szPath[index], &szPath[index + 1], _tcslen(szPath) - index);
				ModifyM_xTip(szPath);
			}
			goto HOOKX;
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::DeleteChar) {
			if (index < _tcslen(szPath)) {
				memmove(&szPath[index], &szPath[index + 1], _tcslen(szPath) - index);
				ModifyM_xTip(szPath);
			}
			goto HOOKX;
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::EndOfLine) {
			index = _tcslen(szPath);
			goto HOOKX;
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::ForwardChar) {
			if (index < _tcslen(szPath)) {
				++index;
			}
			goto HOOKX;
		} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::KeyboardQuit) {
			CCommands::bM_x(FALSE);
			index = 0;
			memset(szPath, 0, sizeof(szPath));	// 
			goto HOOK;
		} else if (nKey == VK_RETURN
				|| Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::Newline) {
			InvokeM_x(szPath);

			CCommands::bM_x(FALSE);
			index = 0;
			memset(szPath, 0, sizeof(szPath));	// 
			goto HOOK;
		} else if (index < MAX_PATH - 1) {
			const BOOL bIsShiftDown = CXkeymacsDll::IsDown(VK_SHIFT);
			for (BYTE nAscii = 1; nAscii != 0; ++nAscii) { // repeat until overflow
				if (nKey != 0 && a2v(nAscii) == nKey && bIsShiftDown == IsShift(nAscii)) {
//					CUtils::Log("M-x: %#X (%c), %#X (%c)", nKey, nKey, nAscii, nAscii);
					if (index < _tcslen(szPath)) {
						memmove(&szPath[index + 1], &szPath[index], __min(_tcslen(szPath) - index, MAX_PATH - (index + 1) - 1));
					}
					szPath[index++] = nAscii;
//					CUtils::Log("M-x: %c(%#04x)", nAscii, nAscii);
					ModifyM_xTip(szPath);
					goto HOOKX;
				}
			}
		}
	}

	if (CCommands::bC_u()) {
		if ((nCommandType == NONE) && ('0' <= nKey) && (nKey <= '9')) {
			CCommands::NumericArgument(nKey - '0');
			goto HOOK0_9;
		}
		if ((nCommandType == NONE) && (nKey == 0xBD)) {
			CCommands::NumericArgumentMinus();
			goto HOOK0_9;
		}
	}

	if (Commands[m_nCommandID[m_nApplicationID][nCommandType & ~CONTROL][nKey]].fCommand == CCommands::OneShotModifierCtrl) {
		nOneShotModifier[nKey] = VK_LCONTROL;
		DepressKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = TRUE;
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::OneShotModifierCtrlRepeat) {
		nOneShotModifier[nKey] = VK_LCONTROL;
		DepressKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = TRUE;
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType & ~CONTROL][nKey]].fCommand == CCommands::OneShotModifierCtrlRepeat) {
		ReleaseKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = FALSE;
		Kdu(nKey);
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType & ~META][nKey]].fCommand == CCommands::OneShotModifierAlt) {
		nOneShotModifier[nKey] = VK_LMENU;
		DepressKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = TRUE;
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::OneShotModifierAltRepeat) {
		nOneShotModifier[nKey] = VK_LMENU;
		DepressKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = TRUE;
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType & ~META][nKey]].fCommand == CCommands::OneShotModifierAltRepeat) {
		ReleaseKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = FALSE;
		Kdu(nKey);
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType & ~SHIFT][nKey]].fCommand == CCommands::OneShotModifierShift) {
		nOneShotModifier[nKey] = VK_SHIFT;
		DepressKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = TRUE;
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::OneShotModifierShiftRepeat) {
		nOneShotModifier[nKey] = VK_SHIFT;
		DepressKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = TRUE;
		goto HOOK;
	} else if (Commands[m_nCommandID[m_nApplicationID][nCommandType & ~SHIFT][nKey]].fCommand == CCommands::OneShotModifierShiftRepeat) {
		ReleaseKey(nOneShotModifier[nKey]);
		bCherryOneShotModifier = FALSE;
		Kdu(nKey);
		goto HOOK;
	} else {
		int i;
		for (i = 0; i < MAX_KEY; ++i) {
			if (nOneShotModifier[i] == nKey) {
				break;
			}
		}
		if (i == MAX_KEY) {
			bCherryOneShotModifier = FALSE;
		}
	}

	if (0 <= m_nFunctionID[m_nApplicationID][nCommandType][nKey]
	 && m_nFunctionID[m_nApplicationID][nCommandType][nKey] < MAX_FUNCTION
	 && _tcslen(m_szFunctionDefinition[m_nFunctionID[m_nApplicationID][nCommandType][nKey]])) {
		CallFunction(m_nFunctionID[m_nApplicationID][nCommandType][nKey]);
		CCommands::Reset(GOTO_HOOK);
		goto HOOK;
	}

	if (!Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand) {
		if (nKey == VK_CONTROL
		 || nKey == VK_LCONTROL
		 || nKey == VK_RCONTROL
		 || nKey == VK_MENU
		 || nKey == VK_LMENU
		 || nKey == VK_RMENU
		 || nKey == VK_SHIFT
		 || nKey == VK_LSHIFT
		 || nKey == VK_RSHIFT) {
			goto DO_NOTHING;
		}

		if (!(nCommandType & SHIFT)) {
			if (CCommands::IsSetMark()) {
				if (CCommands::MoveCaret(nKey, nCommandType & CONTROL) != CONTINUE) {
					CCommands::ClearNumericArgument();
					goto HOOK;
				}
				CCommands::SetMark(FALSE);
			}
		}

		if (1 < CCommands::GetNumericArgument()) {
			Kdu(nKey, CCommands::GetNumericArgument());
			CCommands::ClearNumericArgument();
			goto HOOK;
		}

		goto DO_NOTHING;
	}

	if (CCommands::IsTemporarilyDisableXKeymacs()
	 && Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand != CCommands::KeyboardQuit) {
		CCommands::SetTemporarilyDisableXKeymacs(FALSE);
		goto DO_NOTHING;
	}

	if (m_bAtIbeamCursorOnly[m_nApplicationID][nCommandType][nKey]) {
		CURSORINFO cursorinfo = { sizeof(cursorinfo) };
		if (GetCursorInfo(&cursorinfo) && cursorinfo.flags && cursorinfo.hCursor != LoadCursor(NULL, IDC_IBEAM)) {
			goto DO_NOTHING;
		}
	}

	m_bRightControl	= IsDown(VK_RCONTROL);
	m_bRightAlt		= IsDown(VK_RMENU);
	m_bRightShift	= IsDown(VK_RSHIFT);

	if (!bLocked) {
		bLocked = TRUE;
		fCommand = Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand;
RECURSIVE_COMMAND:
		switch (fCommand()) {
		case GOTO_DO_NOTHING:
			bLocked = FALSE;
			goto DO_NOTHING;
		case GOTO_HOOK:
			bLocked = FALSE;
			goto HOOK;
		case GOTO_RECURSIVE:
			goto RECURSIVE;
		case GOTO_HOOKX:
			bLocked = FALSE;
			goto HOOKX;
		case GOTO_HOOK0_9:
			bLocked = FALSE;
			goto HOOK0_9;
		default:
			ASSERT(0);
			bLocked = FALSE;
			goto DO_NOTHING;
		}
	} else {
		goto HOOK_RECURSIVE_KEY;
	}

DO_NOTHING:
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsControl());
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));

	{
		static BOOL bDefiningMacro;	// = FALSE;
		if (m_bDefiningMacro) {
			static BOOL bDown[MAX_KEY];	// = {'\0'};

			if (!bDefiningMacro) {
#ifdef MFCDLL
				while (m_Macro.GetHeadPosition()) {
					KbdMacro_t* pKbdMacro = (KbdMacro_t*)m_Macro.GetAt(m_Macro.GetHeadPosition());
					m_Macro.RemoveHead();
					delete pKbdMacro;
//					pKbdMacro = NULL;
				}
#else
				m_Macro.clear();
#endif
				memset(bDown, 0, sizeof(bDown));
			}

			if ((!(lParam & BEING_RELEASED)) || bDown[wParam]) {
#ifdef MFCDLL
				try {
					KbdMacro_t* pKbdMacro = new KbdMacro;
//					if (pKbdMacro) {
						pKbdMacro->nCode = nCode;
						pKbdMacro->wParam = wParam;
						pKbdMacro->lParam = lParam;
						pKbdMacro->bOriginal = TRUE;
						m_Macro.AddTail((CObject*)pKbdMacro);
//					}
				}
				catch (CMemoryException* e) {
					e->Delete();
//					CUtils::Log("KeyboardProc: 'new' threw an exception");
				}
#else
				KbdMacro_t k = { nCode, wParam, lParam, TRUE };
				m_Macro.push_back(k);	///< @todo Ogbvʂ
#endif
				if (!(lParam & BEING_RELEASED)) {
					bDown[wParam] = TRUE;
				}
			}
		}
		bDefiningMacro = m_bDefiningMacro;
	}

DO_NOTHING_QUIT:
	return ::CallNextHookEx(g_hHookKeyboard, nCode, wParam, lParam);

	/// @todo RECURSIVE_KEYŕAA32/64rbgłǂŏôƔFłĂ邩mF
RECURSIVE:
	Kdu(RECURSIVE_KEY, 1, FALSE);
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsControl());
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	return TRUE;

HOOK:
	CCommands::SetLastCommand(fCommand);
HOOK0_9:
HOOKX:
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsControl());
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
HOOK_RECURSIVE_KEY:
	return TRUE;
}

void CXkeymacsDll::SetApplicationName(int nApplicationID, LPCTSTR szApplicationName)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
//	ZeroMemory(m_szSpecialApp[nApplicationID], sizeof(m_szSpecialApp[nApplicationID]));
	_tcscpy_s(m_szSpecialApp[nApplicationID], szApplicationName);
}

/*
/// @warning SetWindowText MBCS/Unicode}NĂ̂Œ
void CXkeymacsDll::SetWindowText(int nApplicationID, LPCTSTR szWindowText)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
//	ZeroMemory(m_szWindowText[nApplicationID], sizeof(m_szWindowText[nApplicationID]));
	_tcscpy_s(m_szWindowText[nApplicationID], szWindowText);
}
*/

void CXkeymacsDll::SetCommandID(int nApplicationID, int nCommandType, int nKey, int nCommandID)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
	m_nCommandID[nApplicationID][nCommandType][nKey] = nCommandID;
}

void CXkeymacsDll::SetAtIbeamCursorOnly(int nApplicationID, int nCommandType, int nKey, BOOL bAtIbeamCursorOnly)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
	m_bAtIbeamCursorOnly[nApplicationID][nCommandType][nKey] = bAtIbeamCursorOnly;
}

void CXkeymacsDll::SetKillRingMax(int nApplicationID, int nKillRingMax)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
	m_nKillRingMax[nApplicationID] = nKillRingMax;
}

void CXkeymacsDll::SetUseDialogSetting(int nApplicationID, BOOL bUseDialogSetting)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
	m_bUseDialogSetting[nApplicationID] = bUseDialogSetting;
}

// Clear data of nApplicationID
void CXkeymacsDll::Clear(int nApplicationID)
{
	ASSERT(0 <= nApplicationID && nApplicationID < MAX_APP);
	m_szSpecialApp[nApplicationID][0] = _T('\0');	// ZeroMemory(m_szSpecialApp[nApplicationID], sizeof(m_szSpecialApp[nApplicationID]));
	ZeroMemory(m_nCommandID[nApplicationID], sizeof(m_nCommandID[nApplicationID]));
	ZeroMemory(m_bAtIbeamCursorOnly[nApplicationID], sizeof(m_bAtIbeamCursorOnly[nApplicationID]));
	m_nKillRingMax[nApplicationID] = 0;
	m_bUseDialogSetting[nApplicationID] = FALSE;
	m_nSettingStyle[nApplicationID] = 0;
}

BOOL CXkeymacsDll::IsValidKey(BYTE bVk)
{
	if (bVk == 0xf0) {	// 0xf0: Eisu key. GetAsyncKeyState returns the wrong state of Eisu key.
		return FALSE;
	}

	if (CUtils::IsNT()) {
		switch (bVk) {
		case VK_CONTROL:
		case VK_MENU:
		case VK_SHIFT:
			return FALSE;
		default:
			break;
		}
	}

	return TRUE;
}

BOOL CXkeymacsDll::IsDepressedModifier(int (*Modifier)(void), BOOL bPhysicalKey)
{
	BYTE bVk = 0;
	do {
		if (IsValidKey(bVk)
		 && IsDown(bVk, bPhysicalKey)
		 && Commands[m_nCommandID[m_nApplicationID][NONE][bVk]].fCommand == Modifier) {
			return TRUE;
		}
	} while (++bVk);
	return FALSE;
}

BOOL CXkeymacsDll::IsDepressedShiftKeyOnly(BYTE nKey)
{
	if (nKey != VK_SHIFT
	 && nKey != VK_LSHIFT
	 && nKey != VK_RSHIFT) {
		return FALSE;
	}

	BYTE bVk = 0;
	do {
		if (bVk == VK_SHIFT
		 || bVk == VK_LSHIFT
		 || bVk == VK_RSHIFT) {
			continue;
		}

		if (IsDown(bVk)) {
			return FALSE;
		}
	} while (++bVk);
	return TRUE;
}

BOOL CXkeymacsDll::IsControl()
{
	return CCommands::bC_() || IsDepressedModifier(CCommands::C_, FALSE);
}

BOOL CXkeymacsDll::IsMeta()
{
	return CCommands::bM_() || IsDepressedModifier(CCommands::MetaAlt, FALSE);
}

void CXkeymacsDll::AddKillRing(BOOL bNewData)
{
	if (m_nKillRingMax[m_nApplicationID] == 0) {
		return;
	}

	CClipboardSnap* pSnap = new CClipboardSnap;	///< @todo Ogbvʂ
	ASSERT(pSnap);	// if (!pSnap) return;

	// Lv`u2vs
	// ȃLv`ővH
	BOOL bCapture = pSnap->Capture();
	bCapture = pSnap->Capture();	// for "office drawing shape format". Can CClipboardSnap care this problem?	/// @todo 1ڂ͌ołȂ_~[ƂӖȂ̂cH

	if (bCapture) {
		if (bNewData) {
#ifdef MFCDLL
			m_oKillRing.AddHead(pSnap);	///< @todo Ogbvʂ
#else
			m_oKillRing.push_front(pSnap);	///< @todo Ogbvʂ
#endif
		} else {
#ifdef MFCDLL
			if (m_oKillRing.IsEmpty()) {
				m_oKillRing.AddHead(pSnap);	///< @todo Ogbvʂ
			}
#else
			if (m_oKillRing.empty()) {
				m_oKillRing.push_front(pSnap);	///< @todo Ogbvʂ
			}
#endif
			else {
#ifdef MFCDLL
				pSnap = m_oKillRing.GetHead();
#else
				pSnap = m_oKillRing.front();
#endif
				ASSERT(pSnap);
				while (pSnap->GetNext()) pSnap = pSnap->GetNext();
				pSnap->SetNext(pSnap);
			}
		}
	} else {	// Lv`2ڂs
		delete pSnap;
//		pSnap = NULL;
	}

	m_nKillRing = 0;

#ifdef MFCDLL
	if (m_nKillRingMax[m_nApplicationID] < m_oKillRing.GetCount()) {
		pSnap = m_oKillRing.GetTail();
		delete pSnap;
//		pSnap = NULL;
		m_oKillRing.RemoveTail();
	}
#else
	if (m_nKillRingMax[m_nApplicationID] < (int)m_oKillRing.size()) {
		delete m_oKillRing.back();
		m_oKillRing.pop_back();
	}
#endif
}

// Return TRUE if there is another data
// Return FALSE if there is no more data
CClipboardSnap* CXkeymacsDll::GetKillRing(CClipboardSnap* pSnap, BOOL bForce)
{
	if (m_nKillRingMax[m_nApplicationID] == 0) {
		return NULL;
	}

	if (m_oKillRing.IsEmpty()) {
		return NULL;
	}

	m_nKillRing %= m_oKillRing.GetCount();

	if (!bForce) {
#ifdef MFCDLL
		CClipboardSnap* pKillRing = m_oKillRing.GetAt(m_oKillRing.FindIndex(m_nKillRing));
#else
		list<CClipboardSnap*>::iterator i = m_oKillRing.begin();
		for (int j = 0; j < m_nKillRing; j++) i++;
		CClipboardSnap* pKillRing = *i;
#endif
		ASSERT(pKillRing);	// if (!pKillRing) return NULL;
		while (pKillRing->GetNext()) pKillRing = pKillRing->GetNext();

		// Lv`u1vsȂĎwʒu̓eƓł邱ƂmF
		// ȃLv`ővH
		CClipboardSnap oCurrentSnap;
		oCurrentSnap.Capture();
		if (*pKillRing != oCurrentSnap) return NULL;

		// 
		if (pSnap == NULL) pSnap = pKillRing;
	} else {
		if (pSnap == NULL) {
#ifdef MFCDLL
			pSnap = m_oKillRing.GetAt(m_oKillRing.FindIndex(m_nKillRing));
#else
			list<CClipboardSnap*>::iterator i = m_oKillRing.begin();
			for (int j = 0; j < m_nKillRing; j++) i++;
			pSnap = *i;
#endif
		}
	}

	ASSERT(pSnap);
	pSnap->Restore();

	return pSnap->GetNext();
}

void CXkeymacsDll::Original(int nCommandType, BYTE bVk, int nOriginal)
{
	nCommandType &= ~SHIFT;

	if (CUtils::IsNT()) {
		switch (bVk) {
		case VK_CONTROL:
			bVk = VK_LCONTROL;
			break;
		case VK_MENU:
			bVk = VK_LMENU;
			break;
		case VK_SHIFT:
			bVk = VK_LSHIFT;
			break;
		default:
			break;
		}
	}

	m_nOriginal[nCommandType][bVk] += nOriginal;
}

int CXkeymacsDll::Original(int nCommandType, BYTE bVk)
{
	nCommandType &= ~SHIFT;

	if (CUtils::IsNT()) {
		switch (bVk) {
		case VK_CONTROL:
			bVk = VK_LCONTROL;
			break;
		case VK_MENU:
			bVk = VK_LMENU;
			break;
		case VK_SHIFT:
			bVk = VK_LSHIFT;
			break;
		default:
			break;
		}
	}

	return m_nOriginal[nCommandType][bVk];
}

void CXkeymacsDll::IncreaseKillRingIndex(int nKillRing)
{
	m_nKillRing += nKillRing;
}

/*
// nobody use
int CXkeymacsDll::GetMickey(int nDifferential, int nThreshold1, int nThreshold2, int nAcceleration, int nSpeed)
{
	nDifferential = nDifferential * 10 / nSpeed;

	switch (nAcceleration) {
	case 2:
		if (nThreshold2 < fabs((double)(nDifferential / 4))) {
			nDifferential /= 4;
			break;
		}
		// Do NOT write break; here.
	case 1:
		if (nThreshold1 < fabs((double)(nDifferential / 2))) {
			nDifferential /= 2;
		}
		break;
	case 0:
		break;
	default:
		ASSERT(0);
		break;
	}

	return nDifferential;
}
*/


void CXkeymacsDll::SetSettingStyle(int nApplicationID, int nSettingStyle)
{
	m_nSettingStyle[nApplicationID] = nSettingStyle;
}

void CXkeymacsDll::SetIgnoreUndefinedMetaCtrl(int nApplicationID, BOOL bIgnoreUndefinedMetaCtrl)
{
	m_bIgnoreUndefinedMetaCtrl[nApplicationID] = bIgnoreUndefinedMetaCtrl;
}

void CXkeymacsDll::SetIgnoreUndefinedC_x(int nApplicationID, BOOL bIgnoreUndefinedC_x)
{
	m_bIgnoreUndefinedC_x[nApplicationID] = bIgnoreUndefinedC_x;
}

void CXkeymacsDll::SetEnableCUA(int nApplicationID, BOOL bEnableCUA)
{
	m_bEnableCUA[nApplicationID] = bEnableCUA;
}

BOOL CXkeymacsDll::GetEnableCUA()
{
	return m_bEnableCUA[m_nApplicationID];
}

void CXkeymacsDll::DefiningMacro(BOOL bDefiningMacro)
{
	m_bDefiningMacro = bDefiningMacro;

	if (bDefiningMacro) {	// start-kbd-macro
		if (CCommands::bC_u()) {
			ReleaseKey(VK_SHIFT);
			CallMacro();
		}
	} else {				// end-kbd-macro
#ifdef MFCDLL
		while (!m_Macro.IsEmpty()) {
			KbdMacro_t* pKbdMacro = (KbdMacro_t*)m_Macro.GetTail();
			if (pKbdMacro->lParam & BEING_RELEASED) break;
			m_Macro.RemoveTail();
			delete pKbdMacro;
//			pKbdMacro = NULL;
		}
#else
		while (!m_Macro.empty()) {
			KbdMacro_t& k = m_Macro.back();
			if (k.lParam & BEING_RELEASED) break;
			m_Macro.pop_back();
		}
#endif

		if (!m_Macro.IsEmpty()) {
			static HANDLE hMacro;	// = NULL;
			if (!hMacro) {
				/// 3y[W(12KB)̃}bsÖ擾 (vZXIOSJH)
				hMacro = ::CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, 0x3000, _T("macro"));
				ASSERT(hMacro);		// if (hMacro == INVALID_HANDLE_VALUE) hMacro = NULL;
			}
//			if (hMacro) {
				KbdMacro_t* pView = (KbdMacro_t*)::MapViewOfFile(hMacro, FILE_MAP_ALL_ACCESS, 0, 0, 0);
				if (pView) {
					/// @bug ]͈͂̈ǂ`FbNĂȂ
					/// @note ŏIIȓ]悪}bsÖ(12KB)ƏŎpȂ̂łΉϒ̍\ŊǗKv͂Ȃ̂Ȃ
#ifdef MFCDLL
					INT_PTR n = m_Macro.GetCount();
					for (int i = 0; i < n; i++)	// serialize
						pView[i] = *(KbdMacro_t*)m_Macro.GetAt(m_Macro.FindIndex(i));
#else
					ASSERT(sizeof(m_Macro[0]) * m_Macro.size() <= 0x3000);
					memcpy(pView, &m_Macro[0], sizeof(m_Macro[0]) * m_Macro.size());
#endif
					::UnmapViewOfFile(pView);
				}
//			}
		}
	}
}

BOOL CXkeymacsDll::DefiningMacro()
{
	return m_bDefiningMacro;
}

void CXkeymacsDll::CallMacro()
{
	BOOL bIsCtrlDown = IsDown(VK_CONTROL);
	if (bIsCtrlDown) {
		ReleaseKey(VK_CONTROL);
	}
	BOOL bIsAltDown = IsDown(VK_MENU);
	if (bIsAltDown) {
		ReleaseKey(VK_MENU);
	}
	BOOL bIsShiftDown = IsDown(VK_SHIFT);
	if (bIsShiftDown) {
		ReleaseKey(VK_SHIFT);
	}

#ifdef MFCDLL
	for (POSITION pos = m_Macro.GetHeadPosition(); pos; ) {
		KbdMacro_t* pKbdMacro = (KbdMacro_t*)m_Macro.GetNext(pos);
#else
	for (auto i = m_Macro.begin(); i != m_Macro.end(); i++) {
		KbdMacro_t* pKbdMacro = &*i;
#endif
		if (pKbdMacro->lParam & BEING_RELEASED) {
			ReleaseKey((BYTE)pKbdMacro->wParam);
		} else {
			DepressKey((BYTE)pKbdMacro->wParam, pKbdMacro->bOriginal);
		}
	}

	if (bIsCtrlDown) {
		DepressKey(VK_CONTROL);
	}
	if (bIsAltDown) {
		DepressKey(VK_MENU);
	}
	if (bIsShiftDown) {
		DepressKey(VK_SHIFT);
	}
}

/*
void CXkeymacsDll::CallMacro()	// for debug
{
	CString sz;
	for (POSITION pos = m_Macro.GetHeadPosition(); pos; ) {
		KbdMacro_t *pKbdMacro = (KbdMacro_t*)m_Macro.GetNext(pos);
		if (pKbdMacro->lParam & BEING_RELEASED) {
			CString t;
			t.Format(_T("0x%xu "), pKbdMacro->wParam);
			sz += t;
		} else {
			CString t;
			t.Format(_T("0x%xd "), pKbdMacro->wParam);
			sz += t;
		}
	}
//	CUtils::Log(sz);
}
*/

int CXkeymacsDll::IsPassThrough(BYTE nKey)
{
	BYTE bVk = 0;
	do {
		if (IsDown(bVk)
		 && (Commands[m_nCommandID[m_nApplicationID][NONE][bVk]].fCommand == CCommands::PassThrough)) {
			if (bVk == nKey) {
				return GOTO_HOOK;
			}

			return GOTO_DO_NOTHING;
		}
	} while (++bVk);
	return CONTINUE;
}

void CXkeymacsDll::SetFunctionKey(int nFunctionID, int nApplicationID, int nCommandType, int nKey)
{
	if (nApplicationID	< 0 || MAX_APP			<= nApplicationID
	 || nCommandType	< 0 || MAX_COMMAND_TYPE	<= nCommandType
	 || nKey			< 0 || MAX_KEY			<= nKey) {
		return;
	}

	m_nFunctionID[nApplicationID][nCommandType][nKey] = nFunctionID;
}

void CXkeymacsDll::ClearFunctionDefinition()
{
	memset(m_nFunctionID, -1, sizeof(m_nFunctionID));
	memset(m_szFunctionDefinition, 0, sizeof(m_szFunctionDefinition));	// R[hTCYD
}

void CXkeymacsDll::SetFunctionDefinition(int nFunctionID, LPCTSTR szDefinition)
{
	if (nFunctionID < 0 || MAX_FUNCTION <= nFunctionID) {
		return;
	}

	// memset(m_szFunctionDefinition[nFunctionID], 0, sizeof(m_szFunctionDefinition[nFunctionID]));
	// _stprintf(m_szFunctionDefinition[nFunctionID], _T("%s"), szDefinition);
	_tcscpy_s(m_szFunctionDefinition[nFunctionID], szDefinition);

	return;

}

// call an original command which is defined in dot.xkeymacs
void CXkeymacsDll::CallFunction(int nFunctionID)
{
#ifdef MFCDLL
	CArray<KeyBind_t, KeyBind_t> keybinds;
#else
	vector<KeyBind_t> keybinds;
#endif

	if (nFunctionID < 0 || MAX_FUNCTION <= nFunctionID || !_tcslen(m_szFunctionDefinition[nFunctionID])) {
		return;
	}

	BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
	BOOL bIsAltDown = CXkeymacsDll::IsDown(VK_MENU);
	BOOL bIsShiftDown = CXkeymacsDll::IsDown(VK_SHIFT);

	if (m_szFunctionDefinition[nFunctionID][0] == _T('"') && m_szFunctionDefinition[nFunctionID][_tcslen(m_szFunctionDefinition[nFunctionID]) - 1] == _T('"')) {
		for (unsigned int i = 1; i < _tcslen(m_szFunctionDefinition[nFunctionID]) - 1; ++i) {	// skip '"'
#ifdef MFCDLL
			keybinds.Add(ParseKey(nFunctionID, i));	///< Ogbvʂ
#else
			keybinds.push_back(ParseKey(nFunctionID, i));	///< Ogbvʂ
#endif
		}
	} else if (m_szFunctionDefinition[nFunctionID][0] == _T('[') && m_szFunctionDefinition[nFunctionID][_tcslen(m_szFunctionDefinition[nFunctionID]) - 1] == _T(']')) {
		for (UINT i = 1; i < _tcslen(m_szFunctionDefinition[nFunctionID]) - 1; ++i) {	// skip '[' and ']'
			if (m_szFunctionDefinition[nFunctionID][i] == _T('?')) {	// [?f ?o ?o]
				++i;
#ifdef MFCDLL
				keybinds.Add(ParseKey(nFunctionID, i));	///< Ogbvʂ
#else
				keybinds.push_back(ParseKey(nFunctionID, i));	///< Ogbvʂ
#endif
			} else {												// [ControlCharacter]
				for (int nKeyID = 0; nKeyID < countof(ControlCharacters); ++nKeyID) {
					if (!_tcsncmp(m_szFunctionDefinition[nFunctionID] + i, ControlCharacters[nKeyID].name, _tcslen(ControlCharacters[nKeyID].name))) {
						KeyBind_t keybind = {NONE, ControlCharacters[nKeyID].bVk};
#ifdef MFCDLL
						keybinds.Add(keybind);	///< Ogbvʂ
#else
						keybinds.push_back(keybind);	///< Ogbvʂ
#endif
						i += (UINT)_tcslen(ControlCharacters[nKeyID].name);
						break;
					}
				}
			}
		}
	} else {
		return;
	}

	BOOL bM_x = FALSE;
	TCHAR szPath[MAX_PATH];	// = { 0 };
	unsigned int index = 0;
	BOOL bInitialized = FALSE;

	for (int i = 0; i < keybinds.GetSize(); ++i) {
		const int nCommandType = keybinds.GetAt(i).nCommandType;
		const BYTE bVk = keybinds.GetAt(i).bVk;

		if (nCommandType < MAX_COMMAND_TYPE && Commands[m_nCommandID[m_nApplicationID][nCommandType][bVk]].fCommand) {
			if (Commands[m_nCommandID[m_nApplicationID][nCommandType][bVk]].fCommand == CCommands::ExecuteExtendedCommand) {
				bM_x = TRUE;
			} else if (!bInitialized) {
				if (bIsCtrlDown) {
					CUtilsEx::UpdateKeyboardState(VK_CONTROL, 0);
					ReleaseKey(VK_CONTROL);
				}

				if (bIsAltDown) {
					ReleaseKey(VK_MENU);
				}

				if (bIsShiftDown) {
					ReleaseKey(VK_SHIFT);
				}

				bInitialized = TRUE;
			}
//			CUtils::Log("CallFunction: Command Name: %s", Commands[m_nCommandID[m_nApplicationID][nCommandType][bVk]].szCommandName);
			while (Commands[m_nCommandID[m_nApplicationID][nCommandType][bVk]].fCommand() == GOTO_RECURSIVE) {
				;
			}
		} else if (bM_x) {
			if (bVk == VK_RETURN) {
				szPath[index] = _T('\0');
				InvokeM_x(szPath);	/// @todo ̌ index ωȂǂmFBindex I[o[t[ȂmF
			} else {
				for (BYTE nAscii = 1; nAscii != 0; ++nAscii) { // repeat until overflow
					if (bVk != 0 && a2v(nAscii) == bVk && ((nCommandType & SHIFT) != 0) == IsShift(nAscii)) {
//						CUtils::Log("M-x: %#X (%c), %#X (%c)", bVk, bVk, nAscii, nAscii);
						szPath[index++] = nAscii;
						break;
					}
				}
			}
		} else {
			if (!bInitialized) {
				if (bIsCtrlDown) {
					CUtilsEx::UpdateKeyboardState(VK_CONTROL, 0);
					ReleaseKey(VK_CONTROL);
				}

				if (bIsAltDown) {
					ReleaseKey(VK_MENU);
				}

				if (bIsShiftDown) {
					ReleaseKey(VK_SHIFT);
				}

				bInitialized = TRUE;
			}
			if (nCommandType & WIN_WIN) {
				DepressKey(VK_LWIN);
			}
			if (nCommandType & WIN_CTRL) {
				DepressKey(VK_CONTROL);
			}
			if (nCommandType & WIN_ALT) {
				DepressKey(VK_MENU);
			}
			if (nCommandType & SHIFT) {
				DepressKey(VK_SHIFT);
			}

			Kdu(bVk);

			if (nCommandType & SHIFT && (keybinds.GetSize() <= i + 1 || !(keybinds.GetAt(i + 1).nCommandType & SHIFT))) {
				ReleaseKey(VK_SHIFT);
			}
			if (nCommandType & WIN_ALT && (keybinds.GetSize() <= i + 1 || !(keybinds.GetAt(i + 1).nCommandType & WIN_ALT))) {
				ReleaseKey(VK_MENU);
			}
			if (nCommandType & WIN_CTRL && (keybinds.GetSize() <= i + 1 || !(keybinds.GetAt(i + 1).nCommandType & WIN_CTRL))) {
				ReleaseKey(VK_CONTROL);
			}
			if (nCommandType & WIN_WIN && (keybinds.GetSize() <= i + 1 || !(keybinds.GetAt(i + 1).nCommandType & WIN_WIN))) {
				ReleaseKey(VK_LWIN);
			}
		}
	}

#ifdef MFCDLL
	keybinds.RemoveAll();
#else
	// fXgN^ɔĈ`
#endif

	if (bInitialized) {
		// If these lines are invoked at M-x, a window transition does not work well.

		if (bIsShiftDown) {
			DepressKey(VK_SHIFT);
		}

		if (bIsAltDown) {
			DepressKey(VK_MENU);
		}

		if (bIsCtrlDown) {
			DepressKey(VK_CONTROL);
			CUtilsEx::UpdateKeyboardState(VK_CONTROL, 1);
		}
	}
	return;
}

KeyBind_t CXkeymacsDll::ParseKey(const int nFunctionID, unsigned int &i)
{
	KeyBind keybind = {NONE};

	if (m_szFunctionDefinition[nFunctionID][i] == _T('\\')) {
		++i;
		BOOL bFound = FALSE;
		do {
			bFound = FALSE;
			for (int ModifierID = 0; ModifierID < countof(Modifiers); ++ModifierID) {
				if (!_tcsncmp(m_szFunctionDefinition[nFunctionID] + i, Modifiers[ModifierID].name, _tcslen(Modifiers[ModifierID].name))
				 && _tcslen(Modifiers[ModifierID].name) < _tcslen(m_szFunctionDefinition[nFunctionID] + i)) {
					keybind.nCommandType |= Modifiers[ModifierID].id;
					i += (UINT)_tcslen(Modifiers[ModifierID].name);
					bFound = TRUE;
				}
			}
		} while (bFound);
	}
	if (IsShift(m_szFunctionDefinition[nFunctionID][i]) && !(keybind.nCommandType & (WIN_CTRL | WIN_ALT | WIN_WIN))) {
		keybind.nCommandType |= SHIFT;
	}

	int nKeyID;
	for (nKeyID = 0; nKeyID < countof(ControlCharacters); ++nKeyID) {
		if (!_tcsncmp(m_szFunctionDefinition[nFunctionID] + i, ControlCharacters[nKeyID].name, _tcslen(ControlCharacters[nKeyID].name))) {
			i += (UINT)_tcslen(ControlCharacters[nKeyID].name);
			break;
		}
	}
	if (nKeyID < countof(ControlCharacters)) {
		keybind.bVk = ControlCharacters[nKeyID].bVk;
	} else {
		keybind.bVk = a2v(m_szFunctionDefinition[nFunctionID][i]);
	}

	return keybind;
}

BOOL CXkeymacsDll::IsShift(TCHAR nAscii)
{
	switch (nAscii) {
	case _T(' '):
		return FALSE;
	case _T('!'):
	case _T('"'):
	case _T('#'):
	case _T('$'):
	case _T('%'):
	case _T('&'):
		return TRUE;
	case _T('\''):
		return Is106Keyboard();
	case _T('('):
	case _T(')'):
	case _T('*'):
	case _T('+'):
		return TRUE;
	case _T(','):
	case _T('-'):
	case _T('.'):
	case _T('/'):
	case _T('0'): case _T('1'): case _T('2'): case _T('3'): case _T('4'): case _T('5'): case _T('6'): case _T('7'): case _T('8'): case _T('9'):
		return FALSE;
	case _T(':'):
		return !Is106Keyboard();
	case _T(';'):
		return FALSE;
	case _T('<'):
		return TRUE;
	case _T('='):
		return Is106Keyboard();
	case _T('>'):
	case _T('?'):
		return TRUE;
	case _T('@'):
		return !Is106Keyboard();
	case _T('A'): case _T('B'): case _T('C'): case _T('D'): case _T('E'): case _T('F'): case _T('G'): case _T('H'): case _T('I'): case _T('J'):
	case _T('K'): case _T('L'): case _T('M'): case _T('N'): case _T('O'): case _T('P'): case _T('Q'): case _T('R'): case _T('S'): case _T('T'):
	case _T('U'): case _T('V'): case _T('W'): case _T('X'): case _T('Y'): case _T('Z'):
		return TRUE;
	case _T('['):
	case _T('\\'):
	case _T(']'):
		return FALSE;
	case _T('^'):
		return !Is106Keyboard();
	case _T('_'):
		return TRUE;
	case _T('`'):
		return Is106Keyboard();
	case _T('a'): case _T('b'): case _T('c'): case _T('d'): case _T('e'): case _T('f'): case _T('g'): case _T('h'): case _T('i'): case _T('j'):
	case _T('k'): case _T('l'): case _T('m'): case _T('n'): case _T('o'): case _T('p'): case _T('q'): case _T('r'): case _T('s'): case _T('t'):
	case _T('u'): case _T('v'): case _T('w'): case _T('x'): case _T('y'): case _T('z'):
		return FALSE;
	case _T('{'):
	case _T('|'):
	case _T('}'):
	case _T('~'):
		return TRUE;
	default:
		return FALSE;
	}
}

BYTE CXkeymacsDll::a2v(TCHAR nAscii)
{
	switch (nAscii) {
	case _T(' '):
		return VK_SPACE;
	case _T('!'):
		return '1';
	case _T('"'):
		return Is106Keyboard() ? '2' : (BYTE) 0xde;	// VK_OEM_7
	case _T('#'):
		return '3';
	case _T('$'):
		return '4';
	case _T('%'):
		return '5';
	case _T('&'):
		return Is106Keyboard() ? '6' : '7';
	case _T('\''):
		return Is106Keyboard() ? '7' : (BYTE) 0xde;	// VK_OEM_7
	case _T('('):
		return Is106Keyboard() ? '8' : '9';
	case _T(')'):
		return Is106Keyboard() ? '9' : '0';
	case _T('*'):
		return Is106Keyboard() ? (BYTE) 0xba : '8';	// VK_OEM_1
	case _T('+'):
		return 0xbb;	// VK_OEM_PLUS
	case _T(','):
		return 0xbc;	// VK_OEM_COMMA
	case _T('-'):
		return 0xbd;	// VK_OEM_MINUS
	case _T('.'):
		return 0xbe;	// VK_OEM_PERIOD
	case _T('/'):
		return 0xbf;	// VK_OEM_2
	case _T('0'): case _T('1'): case _T('2'): case _T('3'): case _T('4'): case _T('5'): case _T('6'): case _T('7'): case _T('8'): case _T('9'):
		return (BYTE)nAscii;
	case _T(':'):
		return 0xba;	// VK_OEM_1
	case _T(';'):
		return Is106Keyboard() ? (BYTE) 0xbb : (BYTE) 0xba;	// VK_OEM_PLUS	VK_OEM_1
	case _T('<'):
		return 0xbc;	// VK_OEM_COMMA
	case _T('='):
		return Is106Keyboard() ? (BYTE) 0xbd : (BYTE) 0xbb;	// VK_OEM_MINUS	VK_OEM_PLUS
	case _T('>'):
		return 0xbe;	// VK_OEM_PERIOD
	case _T('?'):
		return 0xbf;	// VK_OEM_2
	case _T('@'):
		return Is106Keyboard() ? (BYTE) 0xc0 : '2';
	case _T('A'): case _T('B'): case _T('C'): case _T('D'): case _T('E'): case _T('F'): case _T('G'): case _T('H'): case _T('I'): case _T('J'):
	case _T('K'): case _T('L'): case _T('M'): case _T('N'): case _T('O'): case _T('P'): case _T('Q'): case _T('R'): case _T('S'): case _T('T'):
	case _T('U'): case _T('V'): case _T('W'): case _T('X'): case _T('Y'): case _T('Z'):
		return (BYTE)nAscii;
	case _T('['):
		return 0xdb;	// VK_OEM_4
	case _T('\\'):
		return 0xdc;	// VK_OEM_5
	case _T(']'):
		return 0xdd;	// VK_OEM_6
	case _T('^'):
		return Is106Keyboard() ? (BYTE) 0xde : '6';	// VK_OEM_7
	case _T('_'):
		return Is106Keyboard() ? (BYTE) 0xe2 : (BYTE) 0xbd;	// VK_OEM_102	VK_OEM_MINUS
	case _T('`'):
		return 0xc0;	// VK_OEM_3
	case _T('a'): case _T('b'): case _T('c'): case _T('d'): case _T('e'): case _T('f'): case _T('g'): case _T('h'): case _T('i'): case _T('j'):
	case _T('k'): case _T('l'): case _T('m'): case _T('n'): case _T('o'): case _T('p'): case _T('q'): case _T('r'): case _T('s'): case _T('t'):
	case _T('u'): case _T('v'): case _T('w'): case _T('x'): case _T('y'): case _T('z'):
		return (BYTE) (nAscii - (_T('a') - _T('A')));
	case _T('{'):
		return 0xdb;	// VK_OEM_4
	case _T('|'):
		return 0xdc;	// VK_OEM_5
	case _T('}'):
		return 0xdd;	// VK_OEM_6
	case _T('~'):
		return Is106Keyboard() ? (BYTE) 0xde : (BYTE) 0xc0;	// VK_OEM_7	VK_OEM_3
	default:
		return 0;
	}
}

void CXkeymacsDll::DeleteAllShell_NotifyIcon()
{
	for (int icon = 0; icon < MAX_ICON_TYPE; ++icon) {
		DeleteShell_NotifyIcon((ICON_TYPE)icon);
	}
}

void CXkeymacsDll::AddAllShell_NotifyIcon()
{
	for (int icon = 0; icon < MAX_ICON_TYPE; ++icon) {
		AddShell_NotifyIcon((ICON_TYPE)icon);
	}
}

void CXkeymacsDll::SetAccelerate(int nAccelerate)
{
	m_nAccelerate = nAccelerate;
}

int CXkeymacsDll::GetAccelerate()
{
	return m_nAccelerate;
}

void CXkeymacsDll::SetKeyboardSpeed(int nKeyboardSpeed)
{
	m_nKeyboardSpeed = nKeyboardSpeed;
}

unsigned int CXkeymacsDll::GetMaxKeyInterval()
{
	// m_nKeyboardSpeed == 0:	slowest repeat rate; approximately  2 characters per second
	// m_nKeyboardSpeed == 31:	fastest repeat rate; approximately 30 characters per second
	// 47 ms is max on my machine w/ KeyboardSpeed 31.
	// 1000 /  2 + 50 = 550
	// 1000 / 30 + 50 = 83
	return (unsigned int) (1000.0 / (2.0 + m_nKeyboardSpeed % 32 * 28.0 / 31.0) + 50.0);
}

void CXkeymacsDll::SetCursorData(HCURSOR hEnable, HCURSOR hDisableTMP, HCURSOR hDisableWOCQ, HICON hDisable, BOOL bEnable)
{
	m_hCursor[STATUS_ENABLE] = hEnable;
	m_hCursor[STATUS_DISABLE_TMP] = hDisableTMP;
	m_hCursor[STATUS_DISABLE_WOCQ] = hDisableWOCQ;
	m_hCursor[STATUS_DISABLE] = hDisable;
	m_bCursor = bEnable;
}

void CXkeymacsDll::DoSetCursor()
{
	if (m_bCursor && m_hCurrentCursor) {
		::SetCursor(m_hCurrentCursor);
	}
}

void CXkeymacsDll::Set106Keyboard(BOOL b106Keyboard)
{
	m_b106Keyboard = b106Keyboard;
}

BOOL CXkeymacsDll::Is106Keyboard()	// const
{
	return m_b106Keyboard;
}

void CXkeymacsDll::Set326Compatible(int nApplicationID, BOOL b326Compatible)
{
	m_b326Compatible[nApplicationID] = b326Compatible;
}

BOOL CXkeymacsDll::Get326Compatible()	// const
{
	return m_b326Compatible[m_nApplicationID];
}

void CXkeymacsDll::InvokeM_x(LPCTSTR szPath)
{
//	CUtils::Log("M-x: szPath=_%s_", szPath);
	int (*fCommand)() = NULL;

	for (int i = 0; i < countof(Commands); ++i) {
		if (_tcsicmp(szPath, Commands[i].szCommandName) == 0) {
			fCommand = Commands[i].fCommand;
			break;
		}
	}

	if (fCommand) {
//		CUtils::Log("M-x: Command: _%s_", Commands[i].szCommandName);
		fCommand();
	} else {
//		CUtils::Log("M-x: Path: _%s_", szPath);
		ShellExecute(NULL, NULL, szPath, NULL, NULL, SW_SHOWNORMAL);
	}
}

void CXkeymacsDll::ModifyM_xTip(LPCTSTR szPath)
{
	if (szPath) {
//		if (_tcslen(szPath) < countof(m_stNtfyIcon[MX_ICON].szTip) - 5) {
//			// memset(m_stNtfyIcon[MX_ICON].szTip, 0, sizeof(m_stNtfyIcon[MX_ICON].szTip));
//			// _stprintf(m_stNtfyIcon[MX_ICON].szTip, _T("M-x %s"), szPath);
//		}
		_stprintf_s(m_stNtfyIcon[MX_ICON].szTip, _T("M-x %s"), szPath);
	} else {
//		memset(m_stNtfyIcon[MX_ICON].szTip, 0, sizeof(m_stNtfyIcon[MX_ICON].szTip));
//		_stprintf(m_stNtfyIcon[MX_ICON].szTip, _T("M-x LED"));
		_tcscpy_s(m_stNtfyIcon[MX_ICON].szTip, _T("M-x LED"));
	}

	ModifyShell_NotifyIcon(MX_ICON, CCommands::bM_x(), TRUE);
}

/*
/// @todo WindowTextTypeɊւ鏈AEBhE^Cg擾鏈CUtilɂ܂Ƃ߂
/// @warning oCgPʂōĂ̂UnicoderhłȂƖ肪邩ȂAǂ݂̂vȂȂ邽ߖȂȂ()
/// @note 킴킴EBhErӐ}sBƁA啶̋ʂȂŎĂ邪ȈvłȂ悤ɎvB
BOOL CXkeymacsDll::IsMatchWindowText(LPCTSTR szWindowText)
{
#ifdef MFCDLL
	BOOL bIsMatchWindowText = TRUE;

	TCHAR szCurrentWindowText[0x100] = {'\0'};
	GetWindowText(GetForegroundWindow(), szCurrentWindowText, countof(szCurrentWindowText));

	CString strWindowText = szWindowText;
	switch (CUtils::GetWindowTextType(szWindowText)) {
	case IDS_WINDOW_TEXT_MATCH:								// *foo*
		strWindowText.Delete(0);								// Delete first '*'
		strWindowText.Delete(strWindowText.GetLength() - 1);	// Delete last '*'
		bIsMatchWindowText = 0 <= CString(szCurrentWindowText).Find(strWindowText);
		break;
	case IDS_WINDOW_TEXT_MATCH_FORWARD:						// foo*
		strWindowText.Delete(strWindowText.GetLength() - 1);	// Delete last '*'
		bIsMatchWindowText = 0 == CString(szCurrentWindowText).Find(strWindowText);
		break;
	case IDS_WINDOW_TEXT_MATCH_BACKWARD:					// *foo
		strWindowText.Delete(0);								// Delete first '*'
		bIsMatchWindowText = 0 <= CString(szCurrentWindowText).Find(strWindowText, CString(szCurrentWindowText).GetLength() - strWindowText.GetLength());
		break;
	case IDS_WINDOW_TEXT_MATCH_FULL:						// foo
		bIsMatchWindowText = strWindowText == szCurrentWindowText;
		break;
	case IDS_WINDOW_TEXT_IGNORE:							// *
		bIsMatchWindowText = TRUE;
		break;
	default:
		ASSERT(0);
		break;
	}

//	CUtils::Log(_T("IsMatchWindowText: %d, _%s_, _%s_"), bIsMatchWindowText, szCurrentWindowText, szWindowText);
	return bIsMatchWindowText;
#else
	TCHAR szCurrent[0x100];	// = {'\0'};
	GetWindowText(GetForegroundWindow(), szCurrent, countof(szCurrent));

	TCHAR buf[0x100];
	size_t n, m;

	switch (CUtils::GetWindowTextType(szWindowText)) {
	case IDS_WINDOW_TEXT_MATCH:								// *foo*
		n = _tcslen(szWindowText);
		_tcscpy_s(buf, szWindowText + (n > 0));
		if (n > 1) buf[n - 2] = _T('\0');
		_tcslwr_s(buf);
		_tcslwr_s(szCurrent);
		return szCurrent <= _tcsstr(szCurrent, buf);

	case IDS_WINDOW_TEXT_MATCH_FORWARD:						// foo*
		n = _tcslen(szWindowText);
		_tcscpy_s(buf, szWindowText);
		if (n >= 1) buf[--n] = _T('\0');
		return _tcsnicmp(szCurrent, buf, n) == 0;

	case IDS_WINDOW_TEXT_MATCH_BACKWARD:					// *foo
		n = _tcslen(szWindowText);
		_tcscpy_s(buf, szWindowText + (n > 0));
		m = _tcslen(szCurrent) + 1;		// n1炵̔j]邽m1𑫂
		return m < n ? FALSE : _tcsicmp(szCurrent + m - n, szWindowText) == 0;

	case IDS_WINDOW_TEXT_MATCH_FULL:						// foo
		return _tcsicmp(szCurrent, szWindowText) == 0;

	case IDS_WINDOW_TEXT_IGNORE:							// *
		break;

	default:
		ASSERT(0);
		break;
	}

	return TRUE;
#endif
}
*/
